#include "semaphore.h"

namespace n2nc {

namespace sync {

Semaphore::Semaphore(uint init_value){
  /* FIXME error check */
  ::sem_init(&this->m_sem,0,init_value);
}

Semaphore::~Semaphore(){
  ::sem_destroy(&this->m_sem);
}
int Semaphore::getValue(){
  int val ;
  ::sem_getvalue(&this->m_sem, &val);
  return val ;
}

bool Semaphore::tryWait(){
  return !::sem_trywait(&this->m_sem);
}
bool Semaphore::wait(){
  return !::sem_wait(&this->m_sem);
}
bool Semaphore::post(){
  return !::sem_post(&this->m_sem);
}


}
}



