#include "logger.h"

namespace n2nc {
namespace system {
/** Initialization block */
bool Logger::m_isloaded = false;
std::ostringstream Logger::m_cout  ;
std::ostringstream Logger::m_os;
std::string Logger::m_logfile ;
Logger* Logger::m_glb_logger = NULL ;
sync::Mutex Logger::m_std_lock ;
sync::Mutex Logger::m_err_lock ;


Logger::Logger(){
  Logger::m_isloaded = false ;
  Logger::m_cout << "lol" ;
}
Logger::~Logger()
{
}

std::ostringstream& Logger::get(){
  return Logger::m_os ;
}

std::ostringstream& Logger::gett(){
  Logger::m_os << "Thread: " << pthread_self() << " " ;
  return Logger::m_os ;
}

// Logger& Logger::operator<<(std::ostringstream str){
//   m_os << str ;
//   return *this ;
// }

// Logger& Logger::operator<<(char *str){
//   m_os << str ;
//   return *this ;
// }
// 
// 
// Logger& Logger::operator<<(std::string str){
//   m_os << str ;
//   return *this ;
// }
// 
// Logger& Logger::operator<<(std::string &str){
//   m_os << str ;
//   return *this ;
// }


int Logger::out(std::string &str){
  std::cout << str << std::endl ;
}
int Logger::out(std::string str){
  std::cout << str << std::endl ;
}
int Logger::out(char *str){
  std::cout << str << std::endl ;
}



void Logger::print(char *frm,...){
  va_list args;
  FILE* logfd=0;

  va_start(args,frm);
  if (!logfd){
    /*open file for logging to*/
    std::string basename(getenv("HOME"));
    std::string filename("/n2nc.log");
    std::string path(basename + filename);
    logfd=fopen(path.c_str(),"w+");
  }
  /*logging methods*/
  switch (2){	/*@TODO make it selectable from define method*/
    case 1:	/*stdout*/
      printf("THREAD %u: ",pthread_self());
      vprintf(frm,args);
      break;
    case 2:	/*stderr*/
      fprintf(stderr,"THREAD %u: ",pthread_self());
      vfprintf(stderr,frm,args);
      break;
    case 3:	/*file*/
      vfprintf(logfd,frm,args);
      break;
  }
  va_end(args);
}

// std::ostringstream &Logger::dlog(){
std::ostream& Logger::dlog(){
/*  if ( Logger::m_glb_logger == NULL )
    Logger::m_glb_logger = new Logger();*/
  std::ostringstream *os = new std::ostringstream();
  Logger::m_err_lock.lock();
  return *os ;
}

std::ostream &Logger::dlog(std::ostream &os){
  return os ;
}



/* '\n' and flush and destroy osteam */
void operator<<(std::ostream& os,Logger::endl_flush_t dummy){
  std::cout << "destroy stream" << std::endl ;
  os << std::endl ;
  std::cout << static_cast<std::ostringstream*>(&os)->str() << std::endl ;
  delete &os ;
}

void operator<<(std::ostream& os,Logger::flush_t dummy){
  std::cout << "destroy stream" << std::endl ;
  os << std::endl ;
  std::cout << static_cast<std::ostringstream*>(&os)->str();
  delete &os ;
}




}
}



