#ifndef N2NC_SYNCMUTEX_H
#define N2NC_SYNCMUTEX_H

#include "nixsys.h"
// #include "condition.h"

namespace n2nc {
namespace sync {

/**
  \brief Mutex implementation

  @author fabsoft <fabsoft@gmail.com>
*/
class Mutex{
  public:
    Mutex();
    ~Mutex();
    bool lock();
    bool trylock();
    bool unlock();
//     Condition *getNewCondition();

  friend class Condition ;

  private:
    pthread_t m_lock_from ;
    pthread_mutex_t m_mutex ;
    Mutex(/*const*/ Mutex& mx); /* FIXME non copyable */
};

// pthread_mutex_t Mutex::m_mutex = PTHREAD_MUTEX_INITIALIZER;

}
}

#endif
