#ifndef N2NCNETWORK_H
#define N2NCNETWORK_H
#include "nixsys.h"

// #include "trackerclient.h"

namespace n2nc {

/**
  \brief This class represents a network.
  
  Basically a network is a VPN's end-point, 
  plus all info about SocketAddress and AAA 
  (Authorization, Authentication and Accounting)

  @author fabsoft <fabsoft@gmail.com>
*/
class Network{
//   private:
  public:
    /* follow declaration */
    class TrackerClient ;
    Network(TrackerClient& tracker);
    ~Network();
    TrackerClient &m_tracker ;

  friend class TrackerClient ;
};

}

#endif
