#ifndef N2NC_NIXSYS_H
#define N2NC_NIXSYS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <errno.h>
#include <stdarg.h>
#include <sys/types.h>
#include <fcntl.h>
/* FIXME include path */
#include </usr/include/semaphore.h>
#include <pthread.h>
/* inet */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/un.h>

#include <time.h>
#include <sys/time.h>

#include <dlfcn.h>

#include <dirent.h>

/* openssl */
#include <openssl/blowfish.h>
#include <openssl/evp.h>
#include <openssl/rsa.h>
#include <openssl/pem.h>
#include <openssl/err.h>


#include <iostream>
#include <sstream>
#include <cstdlib>
#include <vector>
#include <typeinfo>
#include <exception>
#include <list>
#include <set>
#include <map>

/** \addindex myindex 
 * \mainpage Nat 2 Nat Connector Project
 *
 * \section intro_sec Introduction
 *
 * This is the introduction.
 * This project aims to helps
 * introduction continued
 *
 * \section install_sec Installation
 *
 * \subsection step1 Step 1: exec ./configure
 * proceed to step2.
 *
 * \subsection step2 Step 2: exec make
 * proceed to step3.
 *
 * \subsection step3 Step 3: exec make install
 * End
 *
 *
 * Now we have the n2nc library installed to /usr/local/lib if not overwrited by --prefix configure's option
 */


/** 
    \namespace n2nc
    \brief Default project namespace.
    
    n2nc namespace description.
*/

/** 
    \namespace n2nc::net
    \brief Networking related classes.
    
    n2nc::net namespace description.
*/

/** 
    \namespace n2nc::sync
    \brief Synchronization related classes.
    
    n2nc::sync namespace description.
*/
/** 
    \namespace n2nc::system
    \brief System related classes.
    
    n2nc::system namespace description.
*/










#endif
