#ifndef N2NC_SYNCSEMAPHORE_H
#define N2NC_SYNCSEMAPHORE_H

#include "nixsys.h"

namespace n2nc {
namespace sync {

/**
  \brief This class implements the semaphore paradigm.

  @author fabsoft <fabsoft@gmail.com>
*/
class Semaphore{
  public:
    Semaphore(uint init_value = 0);
    ~Semaphore();
    int getValue();
    bool tryWait();
    bool wait();
    bool post();
    
  private:
  sem_t m_sem ;

};

}

}

#endif
