#ifndef N2NC_NETTCPSOCKET_H
#define N2NC_NETTCPSOCKET_H

#include "nixsys.h"
#include "socket.h"

namespace n2nc {
namespace net {

/**
  \brief Tcp Socket implementation.
  @author fabsoft <fabsoft@gmail.com>
*/
class TcpSocket : public Socket
{
public:
    TcpSocket(int af);
//     TcpSocket(int fd, int af);
    ~TcpSocket();

    /** Accept a new incoming connection, @return a new Socket representing the new
    connected socket 
    */
    Socket* accept();
    /** Associate a socketaddress to this socket */
    /** Sets this socket as listenig socket. Once used this socket become connection-oriented socket */
    int setListen(int backlog=10);
    bool isListen();

private:
    TcpSocket();
    bool  m_islisten ;

};

}

}

#endif
