#ifndef N2NCUDPHOLEPUNCHING_TRAVERSAL_H
#define N2NCUDPHOLEPUNCHING_TRAVERSAL_H

#include "traversal.h"

namespace n2nc {

/**
  \brief This class provides Udp Hole Punching NAT traversal method.

  @author fabsoft <fabsoft@gmail.com>
*/
class UdpHolePunching_Traversal : public Traversal {
  public:
    UdpHolePunching_Traversal();
    ~UdpHolePunching_Traversal();

    virtual net::Socket& doConnect ( Network& net );

};

}

#endif
