#include "validargument.h"

namespace n2nc {
namespace utils {
namespace args {

ValidArgument::ValidArgument(string name){
  this->name  = name ;
  this->paramrequired = false ;
}

// ValidArgument::ValidArgument(const ValidArgument & obj){
//   cerr << "copyctr" << endl ;
// }

// ValidArgument::ValidArgument(const ValidArgument& validarg){
//   this->name  = validarg.name ;
//   cerr << "validarg copy ctor: " << this->name << endl ;
// }


ValidArgument::~ValidArgument()
{
}

string ValidArgument::toString(){
  string conflict("") ;
  char stemp[255];
  if (this->conflictsto.size()){
          conflict = " Conflicts with: " + explode(this->conflictsto, ",");
  }
  /* FIXME from java porting*/
  string toformat ;
  toformat = this->name + "{" + explode(this->paramlist,",") + explode(this->paramlist_pattern,",") + "}" ;
//   std::cerr << "name: " << this->name ;
  ::sprintf(stemp,"%-44s",toformat.c_str());
  toformat = stemp + this->comment + conflict ;
  return toformat ;
//   return String.format("%-44s", this.name + "{"+ Argument.explode(this.paramlist,",") + "}") + this.comment + conflict ;
}

/** */
string explode(vector<string>& sl, string delimiter){
  string temp("");
  if(!sl.size())  return "Nothing" ;
  for(int i=0; i < sl.size() ; i++){
    temp += sl[i] + delimiter ;
  }
  if (sl.size() > 0){
          temp = temp.substr(0, temp.size() - delimiter.size());
  }
  return temp ;
}
/*static*/
ValidArgument* ValidArgument::find(string name, vector<ValidArgument>& valids){
  for(int i=0; i < valids.size() ; i++){
    if(valids[i].name == name){
      return &(valids[i]);
    }
  }
  return NULL ;
}


}
}
}



