#ifndef N2NC_SYNCCONDITION_H
#define N2NC_SYNCCONDITION_H

#include "nixsys.h"
#include "mutex.h"

namespace n2nc {
namespace sync {

/**
  \brief Conditional variable implementation

  @author fabsoft <fabsoft@gmail.com>
*/
class Condition{
  public:
    Condition(Mutex& mutex);
    ~Condition();
    bool signal();
    bool signalall();
    bool wait();
    
  private:
    pthread_cond_t m_cond ;
    Mutex &m_mutex ;
    /* FIXME disallow copy */

};

}
}

#endif
