#ifndef N2NCDIRECT_TRAVERSAL_H
#define N2NCDIRECT_TRAVERSAL_H

#include "nixsys.h"
#include "traversal.h"

namespace n2nc {

/**
  \brief This class implements direct traversal(dummy).
  
  This dummy traversal method aim to be used whereas one peer has a public access service,
  in other words has its own public IP or forwarded port to it through the nat service.
  @author fabsoft <fabsoft@gmail.com>
*/
class Direct_Traversal : public Traversal
{
public:
    Direct_Traversal();

    ~Direct_Traversal();
    
    virtual net::Socket& doConnect(Network& net);

};

}

#endif
