#include "filter_dummy.h"

namespace n2nc {

Filter_dummy::Filter_dummy() : Filter("dummy","dummy filter module"){
  std::cerr << "\t\tfilterdummy ctor" << std::endl ;
}


Filter_dummy::~Filter_dummy(){
  std::cerr << "\t\tfilterdummy dtor" << std::endl ;
}

Filter::status_t Filter_dummy::egress(void *inbuf, void *outbuf,size_t inlen,size_t *outlen){
//   std::cerr << "\t\tfilterdummy egress. len: " << inlen << std::endl ;
  memcpy(outbuf,inbuf,inlen);
  *outlen = inlen ;
  return Filter::FILTER_CONTINUE ;
}

Filter::status_t Filter_dummy::ingress(void *inbuf, void *outbuf,size_t inlen,size_t *outlen){
//   std::cerr << "\t\tfilterdummy ingress. len: " << inlen << std::endl ;
  memcpy(outbuf,inbuf,inlen);
  *outlen = inlen ;
  return Filter::FILTER_CONTINUE ;
}


extern "C"
Filter* get_istance(){
  return new Filter_dummy();
}

extern "C"
int free_istance(Filter *filter){
  delete filter ;
}



}

