#ifndef N2NCFILTER_DUMMY_H
#define N2NCFILTER_DUMMY_H

#include <filter.h>

namespace n2nc {

/**
  \brief Dummy transport filter which does NOTHING.
  @author fabsoft <fabsoft@gmail.com>
*/
class Filter_dummy : public Filter
{
public:
    Filter_dummy();
    virtual ~Filter_dummy();
    virtual status_t egress(void *inbuf, void *outbuf,size_t inlen,size_t *outlen) ;
    virtual status_t ingress(void *inbuf, void *outbuf,size_t inlen,size_t *outlen) ;
};

}

#endif
