#ifndef N2NC_H
#define N2NC_H

#include "nixsys.h"

#include "address.h"  //Address class
#include "ctest.h"    //testing class
#include "resolver.h"
#include "socketaddress.h"
#include "socket.h"
#include "tcpsocket.h"
#include "udpsocket.h"
#include "thread.h"
#include "threadtest.h"
// #include "filter.h"    /* crosses include */
#include "logger.h"
#include "configuration.h"
#include "mutex.h"
#include "condition.h"
#include "semaphore.h"
#include "socketeventshandler.h"
#include "argumentshelper.h"

#include "server.h"
#include <libintl.h>

#include "rsa.h"
#include "blowfish.h"
// #include "packetmanager.h"

namespace n2nc{


// enum srv_packet_type{
//   SRV_PK_GARBAGE = 0,
//   SRV_PK_GARBAGE_ACK,
//   SRV_PK_DATA
// };

// struct srv_packet_header{
//   int16_t  h_type ;
//   int16_t  p_size ;
//   int32_t  p_seq ;
//   int32_t  p_chksum ;
//   int32_t  h_aux ;  /**< Auxiliar Data */
// };
// 

struct myconf_t{
  int           sport ; /* server port */
  std::string   saddr ; /* server address */
  int           uport ; /* udp transport port */
  std::string   rsa_pub_path ;  /* rsa public key path */
  uint32_t      myid ;
  uint32_t      otherid ;
  uint32_t      mysrvport ;
  uint32_t      othersrvport ;
  bool          mode_isactive ;
  std::vector<std::string> plugins ;
  std::string   bind_ip ;
  security::BlowFish::key_t skey; /* session key */
  std::string   keydir ;
  std::string   vdepath ;
  int           mss ;
  
};
// typedef srv_packet_header srv_packet_header ;
}

#endif
