#ifndef N2NCTRACKERSERVER_H
#define N2NCTRACKERSERVER_H

#include "nixsys.h"
#include "thread.h"

namespace n2nc {

/**
  \brief This class provides the server tracker implementation.

  \see TrackerClient
  @author fabsoft <fabsoft@gmail.com>
*/
class TrackerServer{
  public:
    TrackerServer();
    ~TrackerServer();

    /** Starts the main listening socket
        \param max_con Indicates the maximum number 
        of connected allowed clients.
    */
    int start(int max_con);

};

}

#endif
